program HelloWorld;

{$APPTYPE CONSOLE}

uses
  ActiveX,
  Printers,
  Windows,
  novaOptions in '..\..\..\include\novaOptions.pas',
  novaEvents in '..\..\..\include\novaEvents.pas',
  novapiLIB90_TLB in '..\..\..\include\novapiLIB90_TLB.pas',
  Nova in 'Nova.pas';

const

  //name of novaPDF Printer
  PRINTER_NAME    = 'novaPDF SDK 9';

  //text to be written in the PDF file
  PDF_TEXT        = 'Hello world from Delphi!';

  //PDF file name
  PDF_FILE_NAME   = 'HelloWorld_Delphi';

  //Print profile name
  PROFILE_NAME    = 'HelloWorld Delphi Profile';
  PROFILE_IS_PUBLIC = 0;

var
  hr : HRESULT;
  pNova : INovaPdfOptions90;
	strOldActiveProfileID : WideString;
	strNewProfileID : WideString;
  bTimeout : Integer;
  //decomment next code if you use workaround for printer index (see below)
  //Device, Driver, Port: array[0..80] of Char;
  //DevMode: THandle;
begin

  //initialize COM
  hr := ActiveX.CoInitialize(nil);
  if (FAILED (hr)) then begin
    System.Writeln('Failed to initialize COM');
    exit;
  end;

  //create one NovaPdfOptions instance
  pNova := nil;
  hr := ActiveX.CoCreateInstance(CLASS_NovaPdfOptions90, //CLSID_CNovaPdfSource,
                                 nil,
                                 CLSCTX_INPROC_SERVER,
                                 IID_INovaPdfOptions90,
                                 pNova);
  if (FAILED(hr))	then begin
    System.Writeln('Failed to create novaPDF COM object');
    exit;
  end;

  // initialize the NovaPdfOptions object to use with a printer licensed for SDK
  // if you have an application license for novaPDF SDK,
  // pass the license key to the Initialize() function
  pNova.Initialize2( PRINTER_NAME, '');

  pNova.SetDefaultPrinter();

  // now the default printer is novaPDF printer but the Printer object is not updated
  // here is a workaround to update the Printer object with the default printer
  // you only need this code if you check later on the Printer.PrinterIndex to find out the default printer
  //Printer.GetPrinter(Device, Driver, Port, DevMode);
  //Printer.SetPrinter(PRINTER_NAME, Driver, Port, 0);

  //create a new profile with default settings
  pNova.AddProfile2(PROFILE_NAME, PROFILE_IS_PUBLIC, strNewProfileID);

  //load the newly created profile
  if SUCCEEDED(hr) and (Length(strNewProfileID) > 0) then begin
	pNova.LoadProfile2(strNewProfileID);
  end else begin
    System.Writeln('Failed to create profile');
    exit;
  end;

  //DO NOT OPEN PDF
  //an Open action is added by default in the profile - delete or disable this open action
  //pNova.DisableActionType(NOVA_ACTION_OPEN);

  // set novaPDF options
  // uncomment the function calls for the options you wish to set and change the options in nova.cpp unit
  //AddProfileOptions(pNova);
  //AddDocumentInformation(pNova);
  //AddDocumentXMPMetadata(pNova);
  //AddViewerOptions(pNova);
  //AddLinksOptions(pNova);
  //AddAdvancedOptions(pNova);
  //AddGraphicsOptions(pNova);
  //AddEmbedFontsOptions(pNova);
  //AddBookmarksDefinitions(pNova);
  //AddSecurity(pNova);
  //AddSaveOptions(pNova);
  //AddMergeOptions(pNova);
  //AddWatermarkImage(pNova);
  //AddWatermarkText(pNova);
  //AddPageContentOptions(pNova);
  //AddOverlayOptions(pNova);
  //AddSignatureOptions(pNova);
  //AddActionsOptions(pNova);

  //save profile changes
  pNova.SaveProfile();

  try
    //get current default profile id
    pNova.GetActiveProfile2(strOldActiveProfileID);
  except
    strOldActiveProfileID := '';
  end;
  //set as active profile for printer
  pNova.SetActiveProfile2(strNewProfileID);

  pNova.RegisterNovaEvent2(NOVAPDF_EVENT_ACTIONS);
  //start print job
  Printer.Title := PDF_FILE_NAME;
  Printer.BeginDoc();
  Printer.Canvas.Font.Size := 24;
  Printer.Canvas.TextOut( 100, 80, PDF_TEXT);
  Printer.endDoc();
  System.Writeln('Print job finished');

  pNova.WaitForNovaEvent(120000, bTimeout);
  if Length(strOldActiveProfileID) > 0 then begin
    //restore default profile
    pNova.SetActiveProfile2(strOldActiveProfileID);
  end;
  pNova.DeleteProfile2(strNewProfileID);
  //resore default printer
  pNova.RestoreDefaultPrinter();

  //release NovaPdfOptions
  //  pNova._Release();

  ActiveX.CoUninitialize();

end.
